/*
  splitter
  mark_borderΤߤƤФ
  ñʬ䤷ΤsegsplitƤӽФ
*/
/*
  word splitterľʸȡǤʸ
  θ󤷰֡ɾι⤤ΤΰĤʸꤹ롣
 */

//#define DEBUG_DEPWORDS
//#define DEBUG_CONJUGATE_TABLE

#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include <dic.h>
#include <wtype.h>
#include <conf.h>
#include <ruleparser.h>
#include "main.h"
#include "context.h"
#include "wordborder.h"

/*ȥƥ*/
static struct anthy_context *g_context;
static struct word_split_info_cache *g_info;
static int g_len;/*ʸοʤΤ*/

#define SEARCH_DEPTH 3
#define SEARCH_LIMIT 2000

/*ñ³롼*/
struct wordseq_rule{
  wtype_t wt;
  char *name;/*ʻ̾(ǥХå)*/
  int node_id;
  struct wordseq_rule *next;
}gRules;

struct seg_cand{
  struct word_list *wl;
  int from,len;
};

static struct split_stat{
  int exhaustive;
  int best_score;
  int initial_depth;
  int final_depth;
  int limit;
  struct seg_cand *se;/*index礭ȤäƤ*/
  struct seg_cand *best_se;
}g_ss;

/*Rule*/
static void print_word_list(struct word_list *);
static void seg_constraint_check(int ,int );
static void calc_best_score(int ,int );
static void make_word_cache();
static void make_word_tree(seq_ent_t se,int from,int len);
static void make_pre_words(seq_ent_t se,struct word_list *);
static void make_suc_words(seq_ent_t se,struct word_list *);
static void make_following_word_list(seq_ent_t se,struct word_list *);
static void shrink_word_list(int i);
static void parse_line(char **,int nr);
static int calc_suffix_affinity(seq_ent_t core,seq_ent_t suffix,int suc);

/**/
static void eval_border(int from,int to);
static int do_split(int from,int to);
static void traverse_words(int from,int to,int depth,int seg_count);
static void check_seg_cand(int ,int ,int );
static int eval_seg_cand(struct seg_cand *);
static void commit_seg_cand(struct seg_cand *);
/**/
void mark_segment_border(struct anthy_context *,int ,int,int );

/*ǥХå*/
void print_word_list(struct word_list *wl)
{
  xstr xs;
  if ( !wl ){
    printf("--\n");
    return ;
  }
  /*prefix*/
  xs.len = wl->core_from - wl->from;
  xs.str = &g_context->str[wl->from];
  putxstr(&xs);
  printf(".");
  /*core*/
  xs.len = wl->core_len;
  xs.str = &g_context->str[wl->core_from];
  putxstr(&xs);
  printf(".");
  /*suffix*/
  xs.len = wl->len - ( wl->core_from - wl->from + wl->core_len);
  xs.str = &g_context->str[wl->core_from+wl->core_len];
  putxstr(&xs);
  printf(" %d %d\n",wl->suffix_len,wl->score);
}

/*äword_list򥳥ߥåȤ*/
void commit_word_list(struct word_list *wl)
{
  int len = wl->core_len;
  int f = ffs(wl->freq)+3;
  if ( f > 8 ){
    f = 8;
  }
  wl->score += 5*len*len*len*f+10000;
  if ( wl->suffix_len ){
    /*ƬФ븺*/
    wl->score -= 5000;
  }
  if ( wl->follow_len ){
    /*°Ф*/
    wl->score += 1500;
  }
  wl->next = g_info->lists[wl->from].next;
  g_info->lists[wl->from].next = wl;
  //print_word_list(wl);
}

int calc_suffix_affinity(seq_ent_t core,seq_ent_t suf,int isSuc)
{
  int a=0;
  if ( ( get_seq_flag(suf) & SF_NUM )&&
       ( get_seq_flag(core) & NF_NUM )){
    a += 5000;
  }
  if ( isSuc &&
       ( get_seq_flag(suf) & SF_JN)&&
       ( get_seq_flag(core) & NF_NAME)){
    a+= 5000;
  }
       
  return a;
}

/*³ν졢ưդ
 */
void make_following_word_list(seq_ent_t se,struct word_list *tmpl)
{
  struct wordseq_rule *r;
  /*ƥ롼˥ޥåƤ뤫ɤĴ٤Ƥ*/
  for ( r = gRules.next ; r ; r = r->next ){
    int freq = get_seq_ent_wtype_freq(se,r->wt);
    if (freq){
      /*ΩʻϤäƤ*/
      xstr xs;
#ifdef DEBUG_CONJUGATE_TABLE
      xs.str = &g_context->str[tmpl->core_from];
      xs.len = tmpl->core_len;
      putxstr(&xs);
      printf(" %s\n",r->name);
#endif
      xs.str = &g_context->str[tmpl->from+tmpl->len];
      xs.len = g_len- tmpl->from - tmpl->len;
      tmpl->freq = freq;
      scan_node(tmpl,&xs,r->node_id);
    }
  }
}

/*򤯤äĤ*/
void make_suc_words(seq_ent_t se,struct word_list *tmpl)
{
  int i;
  for ( i = 1 ; i <= g_info->seq_len[tmpl->core_from+tmpl->core_len];
	i++){
    xstr xs;
    seq_ent_t s;
    xs.str = &g_context->str[tmpl->core_from+tmpl->core_len];
    xs.len = i;
    s = get_seq_ent_from_xstr(&xs);
    if ( get_seq_ent_pos(s,POS_SUC)){
      struct word_list new_tmpl;
      new_tmpl = *tmpl;
      new_tmpl.len += i;
      new_tmpl.suffix_len += i;
      new_tmpl.score += calc_suffix_affinity(new_tmpl.core_seq,s,1);
      make_following_word_list(se,&new_tmpl);
    }
  }
}

/*Ƭ򤯤äĤ*/
void make_pre_words(seq_ent_t se,struct word_list *tmpl)
{
  int i;
  /*Ƭ󤹤*/
  for ( i = 1 ; i <= g_info->rev_seq_len[tmpl->core_from] ;i++){
    xstr xs;
    seq_ent_t s;
    xs.str = &g_context->str[tmpl->core_from-i];
    xs.len = i;
    s = get_seq_ent_from_xstr(&xs);
    if ( get_seq_ent_pos(s,POS_PRE)){
      struct word_list new_tmpl;
      new_tmpl = *tmpl;
      new_tmpl.from = tmpl->from - i;
      new_tmpl.len = tmpl->len +i;
      new_tmpl.score += calc_suffix_affinity(new_tmpl.core_seq,s,0);
      new_tmpl.suffix_len += i;
      make_following_word_list(se,&new_tmpl);
      if ( get_seq_flag(se) & NF_NUM ){
	/*ξ⤯äĤ롣*/
	make_suc_words(se,&new_tmpl);
      }
    }
  }
}

/*ΩФơƬ°դΤ
 ʸθ(=word_list)Ȥcacheɲä롣*/
void make_word_tree(seq_ent_t se,int from,int len)
{
  struct word_list tmpl;
  struct word_list *l;

  tmpl.from = from;
  tmpl.len = len;
  tmpl.core_from = from;
  tmpl.core_len = len;
  tmpl.suffix_len = 0;
  tmpl.follow_len = 0;
  tmpl.core_seq = se;
  tmpl.score = 0;
  /*μΩΤߤʸɲ*/
  l = malloc(sizeof(struct word_list));
  *l = tmpl;
  commit_word_list(l);
  
  /*°ΥꥹȤ롣*/
  if ( get_seq_ent_pos(se,POS_NOUN)){
    /*Ƭ̾ˤդʤȤˤƤ*/
    make_pre_words(se,&tmpl);
    make_suc_words(se,&tmpl);
  }
  make_following_word_list(se,&tmpl);
}

/*ʸᶭ­ʤʸ롣*/
void seg_constraint_check(int from,int to)
{
  int i,j;
  for ( i = from ; i < to ; i++){
    struct word_list *wl;
    for ( wl = g_info->lists[i].next ; wl ; wl = wl-> next){
      wl->can_use = 1;
      for (j = 1 ; j < wl->len ; j++){
	if ( g_context->ce[i+j].seg_border ){
	  wl->can_use = 0;
	}
      }
    }
  }
}

/*ϤޤɤʸΥ׻*/
void calc_best_score(int from,int to)
{
  int i;
  struct word_list *wl;
  for ( i = from ; i < to ; i++ ){
    int best = 0;
    for ( wl = g_info->lists[i].next ; wl ; wl = wl->next ){
      if ( wl->score > best ){
	best = wl->score;
      }
    }
    g_info->best_score[i] = best;
  }
}

/*ƱʸΥ㤤Ʊ˸¤Ӥ*/
void shrink_word_list(int n)
{
  struct word_list *wl,*max,head;
  int i,max_score;
  head.next =0;

  /*ޤν*/
  for ( i = 1 ; i <= g_len ; i++){
    max = 0;
    max_score = -2000000000;
    for ( wl = &g_info->lists[n] ; wl->next ; wl = wl->next ){
      if ( wl->next->len == i && wl->next->score > max_score){
	max_score = wl->next->score;
	max = wl;
      }
    }
    if ( max ){
      wl = max->next;
      /*max->nextȤΥꥹȤڤϤʤ*/
      max->next = max->next->next;
      /*headΥꥹȤˤĤʤ*/
      wl->next = head.next;
      head.next = wl;
    }
  }
  /*ŤΥꥹȤ˻ĤäƤΤϲ*/
  for ( wl = g_info->lists[n].next ; wl ; ){
    struct word_list *tmp;
    tmp = wl->next;
    free(wl);
    wl = tmp;
  }
  g_info->lists[n].next = 0;

  /*˥Ȥ*/
  while( head.next ){
    max = 0;
    max_score = 2000000000;
    /*ΥΤΤ*/
    for ( wl = &head ; wl->next ; wl = wl->next){
      if ( wl->next->score < max_score ){
	max = wl;
	max_score = wl->next->score;
      }
    }
    /*headǻϤޤꥹȤΥ*/
    wl = max->next;
    max->next = wl->next;
    /*ꥹȤɲ*/
    wl->next = g_info->lists[n].next;
    g_info->lists[n].next = wl;
  }
}

/*ǳݤƤrelease_info_cacheǲ롣*/
void make_word_cache()
{
  int i,j;
  xstr xs;
  seq_ent_t se;
  struct depword_ent{
    struct depword_ent *next;
    int from,len;
    seq_ent_t se;
  }head,*de;
  head.next = 0;

  g_context->word_split_info = malloc(sizeof(struct word_split_info_cache));
  g_info = g_context->word_split_info ;
  g_info->seq_len = malloc(sizeof(int)*(g_len+1));
  g_info->rev_seq_len = malloc(sizeof(int)*(g_len+1));
  g_info->lists = malloc(sizeof(struct word_list)*(g_len+1));

  /*ХꥢΤȤޤǽ*/
  for ( i = 0 ; i <= g_len ; i++){
    g_info->seq_len[i] = 0;
    g_info->rev_seq_len[i] = 0;
    g_info->lists[i].next = 0;
  }

  /*ʸĹΥ롼*/
  for ( i = g_len; i > 0 ; i--){
    if ( i > 30 ){
      continue;
    }
    /*Υ롼*/
    for ( j = 0; j <= g_len -i ; j++){
      xs.len = i;
      xs.str = &g_context->str[j];
      se = get_seq_ent_from_xstr(&xs);
      if (se ){
	/*ơʬʸñʤ*/
	if ( i > g_info->seq_len[j] ){
	  g_info->seq_len[j] = i;
	}
	if ( i > g_info->rev_seq_len[j+i] ){
	  g_info->rev_seq_len[i+j] = i;
	}
	/*ΩʤС饹󤹤*/
	if (get_seq_ent_indep(se)){
	  de = (struct depword_ent *)malloc(sizeof(struct depword_ent));
	  de->from = j;
	  de->len = i;
	  de->se = se;
	  de->next = head.next;
	  head.next = de;
	}
      }
    }
  }
  for ( de = head.next ; de ; ){
    struct depword_ent *tmp;
    make_word_tree(de->se,de->from,de->len);
    tmp = de->next;
    free(de);
    de = tmp;
  }
  for ( i = 0 ; i < g_len ; i++){
    //struct word_list *wl;
    shrink_word_list(i);
    //for ( wl = g_info->lists[i].next ; wl ; wl = wl->next)
    //{print_word_list(wl);}
  }
}

void release_info_cache(struct word_split_info_cache *c)
{
  int i;
  struct word_list *wl;
  for ( i = 0 ; i < g_len ; i++){
    for ( wl = c->lists[i].next ; wl ; ){
      struct word_list *tmp;
      tmp = wl;
      wl = wl->next;
      free(tmp);
    }
  }
  free(c->seq_len);
  free(c->rev_seq_len);
  free(c->lists);
}

/*ʸɾԤ*/
int eval_seg_cand(struct seg_cand *e)
{
  if ( !e->wl ){
    return e->len;
  }
  return e->wl->score;
}

/*ʸФɾ򤷤ơ⤱й
  ʸɾeval_seg_candǹԤ
 */
void check_seg_cand(int d,int seg_count,int edge)
{
  int i;
  int sc=0;/*g_info->best_score[edge]*/
  for ( i = d; i < g_ss.initial_depth ;i++){
    sc += eval_seg_cand(&g_ss.se[i]);
    sc += g_ss.se[i].len*1000;
#ifdef DEBUG_DEPWORDS
    print_word_list(g_ss.se[i].wl);
#endif
  }
  if ( seg_count ){
    sc /= seg_count;
  }
#ifdef DEBUG_DEPWORDS
  printf(" %d\n",sc);
#endif
  if ( sc > g_ss.best_score ){
    /**/
    for ( i = d; i < g_ss.initial_depth ;i++){
      g_ss.best_se[i] = g_ss.se[i];
    }
    g_ss.best_score = sc;
    g_ss.final_depth = d;
  }
}

/*
 *ñ춭ФΥ
 *depth0ˤʤ뤫fromtoã뤫Фɾ
 *seg_countϤޤǤͭʸ
 *ȤСʤɤ򥹥󤷤Фˤseg_count
 *κƵƤӽФԤ
 */
void traverse_words(int from,int to,int depth,int seg_count)
{
  struct word_list *wl;
  int i,tmp;
  g_ss.limit--;
  if ( g_ss.limit < 0 ){
    return ;
  }
  if ( to -from == 0 && depth){
    g_ss.exhaustive = 1;
    check_seg_cand(depth,seg_count,to);
    return ;
  }
  if ( depth == 0 ){
    /*ɾ*/
    check_seg_cand(0,seg_count,from);
    return ;
  }
  /*word_list򥹥󤹤*/
  for ( wl = g_info->lists[from].next ; wl ; wl = wl->next ){
    if ( wl->can_use ){
      g_ss.se[depth-1].wl = wl;
      g_ss.se[depth-1].from = wl->from;
      g_ss.se[depth-1].len = wl->len;
      traverse_words(from+wl->len,to,depth-1,seg_count+1);
    }
  }
  /*ϼΩǤʤ*/
  tmp = 0;
  for ( i = 1 ; i <= g_info->seq_len[from] 
	  && !tmp ; i++){
    seq_ent_t se;
    xstr xs;
    xs.str = &g_context->str[from];
    xs.len = i;
    tmp = g_context->ce[from+i].seg_border;
    se = get_seq_ent_from_xstr(&xs);
    if ( se ){
      g_ss.se[depth-1].wl = 0;
      g_ss.se[depth-1].from = from;
      g_ss.se[depth-1].len = i;
      if ( get_seq_ent_type(se) & ST_SEP ){
	/*ʤɤä顢seg_count­ʤ*/
	traverse_words(from+i,to,depth-1,seg_count);
      }else{
	traverse_words(from+i,to,depth-1,seg_count+1);
      }
    }
  }
}

void commit_seg_cand(struct seg_cand *e)
{
  /*Ωword_listκΤߤޡ*/
  if ( e->wl ){
    g_info->seg_border[e->from] = 1;
  }
}

int do_split(int from,int to)
{
  int d = to-from,i;
  g_ss.exhaustive = 0;
  g_ss.best_score = 0;
  if ( d == 0 ){
    return to;
  }
  g_ss.se = alloca(sizeof(struct word_list )*d);
  g_ss.best_se = alloca(sizeof(struct word_list )*d);
  for ( i =0 ; i < d ; i++){
    g_ss.se[i].wl = 0;
  }
  /*ǥƤߤ*/
  g_ss.initial_depth = SEARCH_DEPTH;
  g_ss.limit = SEARCH_LIMIT;
  traverse_words(from,to,SEARCH_DEPTH,0);

  if ( g_ss.exhaustive ){
    /*õǺǸޤǤĤΤ*/
    g_ss.best_score = 0;
    g_ss.initial_depth = d;
    g_ss.limit = SEARCH_LIMIT;
    traverse_words(from,to,d,0);
    /*best seg_candߥå*/
    for ( i = g_ss.final_depth ; i < d ; i++){
      commit_seg_cand(&g_ss.best_se[i]);
    }
    return to;
  }
  if ( g_ss.best_score ){
    /*best seg_candΰʸߥåȤƼʸγ֤*/
    commit_seg_cand(&g_ss.best_se[SEARCH_DEPTH-1]);
    return from+g_ss.best_se[SEARCH_DEPTH-1].len;
  }
  /*ʤ󤫸˼*/
  return to;
}

void eval_border(int from,int to)
{
  /*ʸΤȤΤΤ*/
  seg_constraint_check(from,to);
  /*ϤޤɤʸΥ׻*/
  calc_best_score(from,to);
  /**/
  do{
    from = do_split(from,to);
  }while(from < to);
}

void parse_line(char **tokens,int nr)
{
  struct wordseq_rule *r;
  if ( nr < 2 ){
    printf("Syntex error in indepword defs.\n");
    return ;
  }
  /*ԤƬˤʻ̾äƤ*/
  r = malloc(sizeof(struct wordseq_rule));
  r->name = strdup(tokens[0]);
  str_to_wtype(tokens[0],&r->wt);
  /*μˤϥΡ̾äƤ*/
  r->node_id = get_node_id_by_name(tokens[1]);
  /*롼ɲ*/
  r->next = gRules.next;
  gRules.next = r;
}

void release_word_split_info(struct anthy_context *ac)
{
  if ( !ac->word_split_info){
    return ;
  }
  release_info_cache(ac->word_split_info);
  free(ac->word_split_info);
  ac->word_split_info = 0;
}

void mark_segment_border(struct anthy_context *c,int from,int to,int resize)
{
  int i,n;
  struct seg_ent *s;
  for ( i = from ; i < to ; i++){
    c->ce[i].seg_border = g_info->seg_border[i];
  }
  /**/
  for ( i = 0,n = 0 ; i < from ; i += get_nth_segment_len(c,n) , n++);
  for ( i = from ; i < to ; i++){
    if(c->ce[i].seg_border ){
      s = (struct seg_ent *)malloc(sizeof(struct seg_ent));
      s->str.str = &c->str[i];
      s->str.len = get_nth_segment_len(c,n);
      s->cand_count = 0;
      s->cands = 0;
      s->resized = 0;
      if ( i == from && resize ){
	s->resized = 1;
      }
      push_back_segment(c,s);
      n++;
    }
  }
}

int init_word_seq_tab()
{
  char *fn;
  char **tokens;
  int nr;
  if ( init_depword_tab()){
    return -1;
  }
  fn = conf_get_str("INDEPWORD");
  if (!fn){
    printf("indep word dict unspecified.\n");
    return -1;
  }
  if (open_file(fn) == -1 ){
    printf("failed to open indep word dict (%s).\n",fn);
    return -1;
  }
  gRules.next = 0;
  while( !read_line(&tokens,&nr)){
    parse_line(tokens,nr);
    free_line();
  }
  close_file();
  return 0;
}

/*ƤӽФwordsplitterΥȥåץ٥δؿ*/
void mark_border(struct anthy_context *c,int from,int from2,int to)
{
  int i,j=0;

  if ( (to-from) == 0 ){
    return ;
  }

  g_context = c;
  g_len = g_context->char_count;

  /*ΥƥΩʤɤξ򥭥å夹
    ܤ¹Ԥ*/
  if ( !g_context->word_split_info ){
    make_word_cache();
  }
  g_info = g_context->word_split_info ;
  g_info->seg_border = alloca(sizeof(int)*(c->char_count+1));
  g_info->best_score = alloca(sizeof(int)*(c->char_count+1));
  g_info->best_score[to] = 0;
  for ( i = 0 ; i < c->char_count+1 ; i++){
    g_info->seg_border[i] = c->ce[i].seg_border;
  }

  eval_border(from,to);
  for ( i = from+1 ; i < from2 ; i++){
    g_info->seg_border[i] = 0;
  }
  if ( from == from2 ){
    j = 1;
  }
  mark_segment_border(c,from,to,1);
}
