// -*- C++ -*-
#ifndef _anthyconv_h_included_
#define _anthyconv_h_included_

#include <anthy.h>
#include <list>
#include <vector>

#include "packet.h"

class RKConv;
class RKMap;
struct keyEvent;

typedef int jchar;
typedef list<jchar> jstring;

char *jstring_to_str(jstring *);
void str_to_jstring(jstring *,char *);
void clear_jstring(jstring *);
void append_jstring(jstring *,jstring *);
void print_jchar(jchar );
void print_jstring(jstring *);

#define DO_NOTHING 0
#define COMMIT_RAW 1
#define UPDATE_PREEDIT 2
#define COMMIT_PENDING 4

#define RAW_MODE 0
#define INPUT_MODE 1
#define COMPOSE_MODE 2

struct segment{
  int cur_cand;
  vector<jstring> cands;
};

struct pe_string{
  int stat;
  STRING str;
};

struct preedit{
  vector<pe_string>segs;
};

class AnthyConv{
public:
  AnthyConv(anthy_context_t );
  ~AnthyConv();
  int proc_key(keyEvent *);
  void get_preedit(preedit *);
  STRING get_pending();
private:
  int proc_raw_mode(keyEvent *);
  int proc_input_mode(keyEvent *);
  int proc_compose_mode(keyEvent *);
  void do_conv();
  void update_anthy_stat(int );
  
  int mMode;
  RKConv *mRkConv;
  anthy_context_t mAC;
  jstring mStr;
  vector<segment> mSegs;
  int mCurSeg;
  jstring mCommit;
};

AnthyConv *create_anthy_context();

extern RKMap *rk_hira_map;
extern RKMap *rk_kata_map;

#endif
