#include <stdio.h>
#include <list>
#define KEYATOMS
#include "keybind.h"

class Atom{
public:
  Atom(int code,int ch,int mod){
    addBind(code,ch,mod);
  }
  bool isMatch(int code,int ch,int mod){
    list<keyEvent>::iterator it;
    for ( it = mBinds.begin() ; it != mBinds.end() ; it++){
      if ( (*it).keycode == code && (*it).keychar == ch && (*it).modifier == mod ){
	return true;
      }
    }
    return false;
  }
  void addBind(int code,int ch,int mod){
    keyEvent ev;
    ev.keycode = code;
    ev.keychar = ch;
    ev.modifier = mod;
    mBinds.push_back(ev);
  }
private:
  list<keyEvent> mBinds;
};

void initKeyAtoms()
{
  A_do_conv = new Atom(' ',' ',0);
  A_next_segment = new Atom('F','f',1);
  A_prev_segment = new Atom('B','b',1);
  A_commit = new Atom('\n','\n',0);
  A_expand_segment = new Atom('I','i',1);
  A_shorten_segment = new Atom('O','o',1);  
  A_next_candidate = new Atom('N','n',1);  
}

bool isBindTo(keyEvent *ev,keyAtom a)
{
  return a->isMatch(ev->keycode,ev->keychar,ev->modifier);
}
